"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var glob_1 = require("glob");
var lodash_1 = require("lodash");
var yargs = require("yargs");
var argv = yargs
    .config()
    .option('b', {
    alias: 'port',
    default: 3000,
    describe: 'Port to bind on',
    type: 'number'
})
    .option('d', {
    alias: 'directory',
    default: '.',
    describe: 'Directory of slideshow images',
    type: 'string'
})
    .option('u', {
    alias: 'username',
    describe: 'OurGroceries username',
    type: 'string'
})
    .option('p', {
    alias: 'password',
    describe: 'OurGroceries password',
    type: 'string'
})
    .help()
    .argv;
var Config = /** @class */ (function () {
    function Config() {
    }
    Config.globFiles = function (location) {
        return lodash_1.union([], glob_1.sync(location));
    };
    Config.port = argv.b;
    Config.slides = argv.d;
    Config.username = argv.u;
    Config.password = argv.p;
    Config.routes = path.join(__dirname, '../routes/**/*.js');
    return Config;
}());
exports.default = Config;
//# sourceMappingURL=config.js.map