"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var bodyParser = require("body-parser");
var config_1 = require("./config");
var cookieParser = require("cookie-parser");
var express = require("express");
var logger = require("morgan");
var mustacheExpress = require("mustache-express");
var path = require("path");
function default_1() {
    var app = express();
    app.engine('html', mustacheExpress());
    app.set('view engine', 'html');
    app.set('views', path.resolve(__dirname, '../../views'));
    app.use(logger('dev'));
    app.use(bodyParser.json());
    app.use(bodyParser.urlencoded({ extended: false }));
    app.use(cookieParser());
    app.use(express.static(path.resolve(__dirname, '../../public')));
    console.log('Loading routes...');
    for (var _i = 0, _a = config_1.default.globFiles(config_1.default.routes); _i < _a.length; _i++) {
        var route = _a[_i];
        var location_1 = path.resolve(route);
        console.log("Loading routes from: " + location_1);
        require(location_1).default(app);
    }
    app.use(function (req, res, next) {
        var err = new Error("Not found: " + req.path);
        next(err);
    });
    return app;
}
exports.default = default_1;
;
//# sourceMappingURL=express.js.map