"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var config_1 = require("../config/config");
var OurGroceriesClient = require("our-groceries-client");
function customPromisify(object, key) {
    var method = object[key];
    object[key] = function () {
        var _this = this;
        var args = Array.prototype.slice.call(arguments);
        return new Promise(function (resolve, reject) {
            // Add custom callback handler
            args.push(function (result) {
                if (result.success) {
                    resolve(result.response);
                }
                else {
                    reject(result.error);
                }
            });
            method.apply(_this, args);
        });
    };
}
function createClient() {
    var client = new OurGroceriesClient();
    customPromisify(client, 'authenticate');
    customPromisify(client, 'getLists');
    customPromisify(client, 'getList');
    return client;
}
var ShoppingController = /** @class */ (function () {
    function ShoppingController() {
    }
    ShoppingController.prototype.index = function (req, res) {
        return __awaiter(this, void 0, void 0, function () {
            var listName, client, lists, details, model;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        listName = req.query.list;
                        client = createClient();
                        return [4 /*yield*/, client.authenticate(config_1.default.username, config_1.default.password)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, client.getLists()];
                    case 2:
                        lists = _a.sent();
                        return [4 /*yield*/, Promise.all(lists.shoppingLists
                                .filter(function (list) { return list.activeCount > 0; })
                                .map(function (list) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, client.getList(list.id)];
                                    case 1: return [2 /*return*/, _a.sent()];
                                }
                            }); }); }))];
                    case 3:
                        details = _a.sent();
                        model = details.map(function (detail) {
                            var list = detail.list;
                            return {
                                name: list.name,
                                items: (list.items
                                    .filter(function (item) { return !item.crossedOff; })
                                    .map(function (item) { return item.value; })
                                    .sort())
                            };
                        });
                        res.render('shopping.html', { lists: model });
                        return [2 /*return*/];
                }
            });
        });
    };
    return ShoppingController;
}());
exports.default = ShoppingController;
exports.shoppingController = new ShoppingController();
//# sourceMappingURL=shopping.server.controller.js.map